using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        Graphics gPB,g1pic;
        SolidBrush pbrush;

        Bitmap pic = new Bitmap("Blumen.jpg" );
        
        Pen p = new Pen(Color.Black, 3);
        Brush br= Brushes.Red;
        Point start;

        public Form1()
        {
            InitializeComponent();
            //this.WindowState = MaximumSize;
            //pictureBox1.Dock = DockStyle.Fill;
            label1.Text = this.Width.ToString();
            pbrush = new SolidBrush(Color.LightSkyBlue);
            g1pic = Graphics.FromImage(pic);
        }

        private void buttonLine_Click(object sender, EventArgs e)
        {
            gPB.FillRectangle(pbrush, 0, 0, 100, 100);
            //.Color = Color.LightSkyBlue;
            //g.FillRectangle(pbrush, 0, 0, pictureBox1.Width, pictureBox1.Height);
           
        }


        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            SolidBrush pbrush = new SolidBrush(Color.Blue); 
            e.Graphics.FillRectangle(pbrush, 5, 5, 100, 100);
            
        }

        private void buttonsavePic_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pic.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Jpeg);


            }
        }

        private void buttonLine_Paint(object sender, PaintEventArgs e)
        {
            Pen p = new Pen(Color.Red, 3); 
            Point poi1 = new Point(0, 5);
            Point poi2 = new Point(80, 15);
            e.Graphics.DrawLine(p, poi1, poi2);
        }

        private void statusStrip1_Paint(object sender, PaintEventArgs e)
        {
            Pen p = new Pen(Color.Green, 1);
            Rectangle rec = new Rectangle(200, 3, 250, 15);
            e.Graphics.DrawRectangle(p, rec);
        }

        int alpha = 200; // tranparency of artwork

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            pbrush.Color=Color.Red;
            gPB.FillPie(pbrush, 20, 30, 100, 200, trackBar1.Value, trackBar2.Value);
            alpha = (int)(trackBar1.Value * 255 / 360);
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "1: " + trackBar1.Value.ToString() + " 2: " + trackBar2.Value.ToString();
        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            pic.Dispose();
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                pic = new Bitmap(openFileDialog1.FileName);
                //Rectangle rec = new Rectangle(00, 3, 25, 15);
                g1pic = Graphics.FromImage(pic);
                //g1pic.FillRectangle(pbrush, rec);  // Draw into pic
                gPB.DrawImage(pic, 0, 0, pic.Width, pic.Height);          // Draw on screen
            }

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            p.Width = (int)numericUpDown1.Value;
        }

        private void buttonPenCol_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
                p.Color = colorDialog1.Color;
        }

        private void buttonFilCol_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
                pbrush.Color = colorDialog1.Color;
        }

        bool draw = false;
        
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            draw = true;
            start = e.Location;
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (draw)
            {
                Point endp = e.Location;
                g1pic.DrawLine(p, start, endp);
                gPB.DrawImage(pic, 0, 0, pic.Width, pic.Height);          // Draw on screen
                start = endp;
            }
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            draw = false;
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;
            pictureBox1.Size = Form1.ActiveForm.ClientSize;
            label1.Text = pictureBox1.Width.ToString();
            gPB = Graphics.FromHwnd(pictureBox1.Handle);
        }

        private void buttonArt_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled) timer1.Enabled = false; else timer1.Enabled = true;
            label2.Text = "Transparency";
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Random r = new Random();

            int x1 = r.Next(0, pic.Width);      //x point top left
            int y1 = r.Next(0, pic.Height);     // y point top left
            int x2 = r.Next(0, pic.Width-x1);   // width
            int y2 = r.Next(0, pic.Height-y1);  // height

            Rectangle rect = new Rectangle(x1, y1, x2, y2);

            int red = r.Next(0, 255);
            int green = r.Next(0, 255);
            int blue = r.Next(0, 255);
            //int alpha = r.Next(0, 255); // this value with trackbar1
            pbrush.Color = Color.FromArgb(alpha,red, green, blue);

            int red2 = r.Next(0, 255);
            int green2 = r.Next(0, 255);
            int blue2 = r.Next(0, 255);

            p.Color = Color.FromArgb(alpha, red2, green2, blue2);
            p.Width = r.Next(1, 10);

            g1pic.FillRectangle(pbrush,rect);
            g1pic.DrawRectangle(p, rect);
            gPB.DrawImage(pic, 0, 0, pic.Width, pic.Height);          // Draw on screen


        }
    }
}