﻿using System;
using System.Globalization;  // für CultureInfo

using System.Windows.Forms;   // in Call arguments TextBox

// -------------------------------------------------------------------------
//      public class CHMinMax
//      public class LoadOpt
//      public int Str2NString(string txt, ref string[] val, char sep)
//      public void StrTo2Float(String a, ref double xi, ref double yi,char sep)
//      public int ConvertTB2ChartAdd(ref AxChartfxLib.AxChartfx Chart, TextBox TB, ref CHMinMax chmm, LoadOpt LO)
//      public int ConvertTB2Chart(ref AxChartfxLib.AxChartfx Chart, TextBox TB, LoadOpt LO)
//      public void kttoteta(int processmodel,double[] KTpar, ref double[] teta)
//      public double disturbanceGain(double[] p, double[] q, int m, char algorithm)
//      public void DB_aus_teta(double[] teta, ref double[] p, ref double[] q, int m) /*in:teta,m out: p,q*/
//      public void DB1_aus_teta(double[] teta, ref double[] p, ref double[] q, int m, double r)
//      public void OR_aus_teta(double[] t, ref double[] p, ref double[] q, int m, ref double f3)


namespace WINDF7CSharp
{

    public class DataTools

    {

        //public DataTools()
        //{
            
        //}
        
        ////FormMain meinMain;

        public int maxcrvs = 20;  // max number of curves
        string tetanotdefined = "Array teta is not defined";
        string a1mustbenegative = "a1 must be negative";
        string wrongDataFormat = "wrong Data Format";

        public int Str2NString(string txt, ref string[] val, char sep)
        {// separator defined with RadioButtons in this Form
            // separates the input string txt into any number of substrings separated with separator 
            // output string array is val. Returns the number of strings, which are found
            //char sep = getSeparator();
            string sepstr = sep.ToString();
            int startx, chnb, cnt = 0;
            int pos, px = 0;
            if (txt.Length > 2)
            {// Minimum Lengh is 3 char
                while (txt.Substring(px, 1) == sepstr) px++; //skip leading seps
                startx = px;
                pos = px + 1;
                while ((px >= 0) && (pos < txt.Length))  // search for all separators
                {
                    px = txt.IndexOf(sep, pos);
                    chnb = px - startx;
                    while ((px > -1) && (px < txt.Length - 1) && (txt.Substring(px + 1, 1) == sepstr)) px++; // if more than one sep skip

                    if ((px < txt.Length) && (px >= 0))
                    {

                        val[cnt] = txt.Substring(startx, chnb);
                        cnt++;
                        pos = px + 1;
                        startx = pos;
                    }
                }
                if ((startx != txt.Length) && (px < 0)) // No sep at the end
                {
                    val[cnt] = txt.Substring(startx, txt.Length - startx);
                    cnt++;
                }
            }
            else return (-1);
            return (cnt);
        }


        public void StrTo2Float(String a, ref double xi, ref double yi,char sep)
        // Converts a String with two numbers into two doubles
        {
            string[] outstr = new string[10];
            int cnt = Str2NString(a, ref outstr, sep);
            if (cnt > 1)
            {
                ConvertToDouble(outstr[0],ref xi );
                ConvertToDouble(outstr[1],ref yi );
            }
        }

        public char comF, comR;   // to correct Comma- / point problem comF : wrong seperator
        // comR  : correct separator



        public void ConvertToDouble(string text, ref double nb)
        {
            // Secure Conversion independant of Komma- Version of PC
            // comF contains String with wrong camma, comR contains string with correct comma
            // if number format is wrong, result is old number
            // Call :  ConvertToDouble(text,ref number);
            // removes all thousand- Seperators
            // examples: (if decimal sep =".")
            // 1000,000,000.23 --> 1000000000.23
            // 1000.000.000,23 --> 1000000000.23
            // 0.23 --> 0.23
            // 0,23 --> 0.23
            // 1000,023 --> 1000.023
            // 1000.023 --> 1000.023

            // examples: (if decimal sep =",")
            // 1000,000,000.23 --> 1000000000,23
            // 1000.000.000,23 --> 1000000000,23
            // 0.23 --> 0,23
            // 0,23 --> 0,23
            // 1000,023 --> 1000,023
            // 1000.023 --> 1000,023

            string TestText = (0.1).ToString("f1");

            if (TestText.Substring(1, 1) == ".")  // Check which is the actual Decimal separator
            { comF = ','; comR = '.'; }
            else
            { comF = '.'; comR = ','; }

            double number = 0;
            char[] seps = new char[2];
            seps[0] = ','; // both possible decimal seperators
            seps[1] = '.';
            // check if Thousand- group sign is available. If more than one sign, all left signs are removed
            int index = 0, cnt = 0;
            while (index > -1)  // count number of seperators
            {
                index = text.IndexOfAny(seps, index);  // look for next position of seps
                if (index > -1) { cnt++; index++; }
            }
            string newtext = text;
            if (cnt > 1)  // If more than one sign, all left signs are removed
            {
                string leftSign = text.Substring(text.IndexOfAny(seps), 1);  // what is the left sign?
                newtext = text.Replace(leftSign, "");// Remove all left signs
            }
            string help = newtext.Replace(comF, comR); // Change into correct decimal sep
            if (Double.TryParse(help, out number))
                nb = number;
            else MessageBox.Show(wrongDataFormat);

        }

        
        //---------------------------------------------------------------------------
        public void kttoteta(int processmodel,double[] KTpar, ref double[] teta)
        {
            // KTpar[0] K, KTpar[1] T1, KTpar[2] T2, KTpar[3] T0
             double a1, a2, b1, b2, c, c2, c3, weg, d1, d2, d3, tt1cd, tt2cd;  // kttoteta()

            for (int i = 0; i < teta.Length; i++) teta[i] = 0;//Clear
            switch (processmodel)
            {
                case 1:
                    {  /*it1*/
                        d1 = KTpar[0]* KTpar[1];
                        d2 = KTpar[3] / KTpar[1]; c = Math.Exp(-d2);
                        a1 = -1 - c; a2 = c;
                        b1 = d1 * (d2 - 1 + c); b2 = -d1 * (d2 * c - 1 + c);
                        teta[1] = a1; teta[2] = a2; teta[3] = 0;
                        teta[4] = b1; teta[5] = b2;
                        break;
                    } /*it1*/
                case 0:
                    { /*2Pt1*/
                        tt1cd = KTpar[1];
                        tt2cd = KTpar[2];
                        if (tt1cd < tt2cd) { weg = tt2cd; tt2cd = tt1cd; tt1cd = weg; } /*swap*/
                        c3 = Math.Exp(-KTpar[3] / tt1cd); c2 = Math.Exp(-KTpar[3] / tt2cd);
                        d1 = KTpar[0] * tt1cd * tt2cd / (tt2cd - tt1cd); d2 = 1 / tt1cd - 1 / tt2cd - c2 / tt1cd + c3 / tt2cd;
                        d3 = (1 / tt1cd - 1 / tt2cd) * c2 * c3 - c3 / tt1cd + c2 / tt2cd;
                        a1 = -c2 - c3; a2 = c2 * c3; b1 = d1 * d2; b2 = d1 * d3;
                        teta[1] = a1; teta[2] = a2; teta[3] = 0;
                        teta[4] = b1; teta[5] = b2;
                        break;
                    } /*2pt1*/
                case 2:
                    { /*PT1*/
                        a1 = -Math.Exp(-KTpar[3] / KTpar[1]); b1 = KTpar[0] * (1 + a1);
                         teta[1] = a1; teta[2] = 0; teta[3] = b1;
                        break;
                    } /*Pt1*/
                case 3:
                    { //PT2
                        double d, wo, z0, t0, del, cosw, sinw, w;
                        d = KTpar[1]; wo = KTpar[2]; t0 = KTpar[3];
                        if (d < 1)
                        {
                            z0 = Math.Exp(-d * t0 * wo); del = d * wo; w = wo * Math.Sqrt(1 - d * d);
                            cosw = Math.Cos(w * t0); sinw = del / w * Math.Sin(w * t0);
                            teta[1] = -2 * z0 * cosw;            /*a1*/
                            teta[2] = z0 * z0;
                            teta[4] = KTpar[0] * (1 - z0 * (cosw + sinw));   /*b1*/
                            teta[5] = KTpar[0] * z0 * (z0 - cosw + sinw);
                            teta[3] = 0;
                        }
                        else
                        { // convert into 2PT1
                            tt1cd = (d + Math.Sqrt(d * d - 1)) / wo;
                            tt2cd = (d - Math.Sqrt(d * d - 1)) / wo;
                            if (tt1cd < tt2cd) { weg = tt2cd; tt2cd = tt1cd; tt1cd = weg; } /*swap*/
                            c3 = Math.Exp(-KTpar[3] / tt1cd); c2 = Math.Exp(-KTpar[3] / tt2cd);
                            d1 = KTpar[0] * tt1cd * tt2cd / (tt2cd - tt1cd); d2 = 1 / tt1cd - 1 / tt2cd - c2 / tt1cd + c3 / tt2cd;
                            d3 = (1 / tt1cd - 1 / tt2cd) * c2 * c3 - c3 / tt1cd + c2 / tt2cd;
                            a1 = -c2 - c3; a2 = c2 * c3; b1 = d1 * d2; b2 = d1 * d3;
                            teta[1] = a1; teta[2] = a2; teta[3] = 0;
                            teta[4] = b1; teta[5] = b2;
                        }
                        

                        break;
                    } //PT2
            } /*switch (*/
        }


        public double disturbanceGain(double[] p, double[] q, int m, char algorithm)
        {
            double sp, sq;
            int i;
            sp = 1; for (i = 1; i <= m; i++) sp = sp - p[i];
            sq = 0; for (i = 0; i <= m; i++) sq = sq + q[i];
            if (Math.Abs(sq) > 1e-8) return (sp / sq);
            else //sq=0
                if (Math.Abs(sp) > 1e-8) return (1e10);
                else //sq and sp=0 -. d'hospital
                    if (algorithm == 'i')
                    {
                        sp = 0; for (i = 1; i <= m; i++) sp = sp + i * p[i];
                        sq = 0; for (i = 1; i <= m; i++) sq = sq - i * q[i];
                        if (Math.Abs(sq) > 1e-10) return (sp / sq);
                        else return (1e11);
                    }
                    else
                    { //*r
                        sp = 0; for (i = 1; i <= m; i++) sp = sp + (i + 1) * p[i];
                        sq = 0; for (i = 1; i <= m; i++) sq = sq - i * q[i];
                        if (Math.Abs(sq) > 1e-10) return (sp / sq);
                        else return (1e12);
                    }

        }



        //---------------------------------------------------------------------------



        public void DB_aus_teta(double[] teta, ref double[] p, ref double[] q, int m) /*in:teta,m out: p,q*/
        {
            /* version with b0 in teta, b0 will be ignored */
            int hzp;
            double hv, q0;
            hv = 0;
            for (hzp = 0; hzp < p.Length; hzp++) p[hzp] = 0; // Clear
            for (hzp = 0; hzp < q.Length; hzp++) q[hzp] = 0; 

            for (hzp = 1; hzp <= m; hzp++) hv = hv + teta[m + hzp + 1];
            if (hv == 0) hv = 1000; else hv = 1.0 / hv;
            q0 = hv;
            q[0] = q0;
            for (hzp = 1; hzp <= m; hzp++)
            {
                q[hzp] = q0 * teta[hzp];
                p[hzp] = q0 * teta[m + hzp + 1];
            }


        } /*DB_aus_teta*/
        //---------------------------------------------------------------------------

        public void DB1_aus_teta(double[] teta, ref double[] p, ref double[] q, int m, double r)
        /*in:teta,m,r out p,q*/
        /* version with b0 in teta, b0 will be ignored */
        {
            int hzp;
            double hv, q0, q0max, q0min;
            hv = 0;
            for (hzp = 0; hzp < p.Length; hzp++) p[hzp] = 0; // Clear
            for (hzp = 0; hzp < q.Length; hzp++) q[hzp] = 0;
            
            for (hzp = 1; hzp <= m; hzp++) hv = hv + teta[m + hzp + 1];
            if (hv == 0) hv = 1000; else hv = 1.0 / hv;
            if ((1 - teta[1]) == 0) q0min = 1000; else q0min = hv / (1 - teta[1]);
            q0max = hv;
            q0 = q0min + (1 - r) * (q0max - q0min);
            q[0] = q0;
            q[1] = q0 * (teta[1] - 1) + hv;
            p[1] = q0 * teta[m + 2];
            if (m > 1)
            {
                for (hzp = 2; hzp <= m; hzp++)
                    q[hzp] = q0 * (teta[hzp] - teta[hzp - 1]) + teta[hzp - 1] * hv;
                for (hzp = 2; hzp <= m; hzp++)
                    p[hzp] = q0 * (teta[m + hzp + 1] - teta[m + hzp])
                                   + teta[m + hzp] * hv;
            }
            q[m + 1] = teta[m] * (-q0 + hv);
            p[m + 1] = -teta[m + m + 1] * (q0 - hv);
        } /*DB1_aus_teta*/

        //---------------------------------------------------------------------------

        public void OR_aus_teta(double[] t, ref double[] p, ref double[] q, int m, ref double f3)

                /* version with b0 in teta, b0 will be ignored */
        {
            int i,hzp;
            double[] a = new double[m+3];
            double[] b = new double[m+3];
            double h1, hvkl;
            /* Orientierungsregler (nur m<=3)
               nach W. Ehrlich Automatisierungstechnik 39(1991) 8 S. 272*/
            /* erst Umtopfen zum besseren Verständnis */

            for (hzp = 0; hzp < p.Length; hzp++) p[hzp] = 0; // Clear
            for (hzp = 0; hzp < q.Length; hzp++) q[hzp] = 0; 

            for (i = 1; i <= m; i++) { a[i] = t[i]; b[i] = t[i + m + 1]; }
            a[0] = 1; b[0] = 0;
            for (i = m + 1; i <= m + 2; i++) { a[i] = 0; b[i] = 0; }
            hvkl = a[1] * a[1] - a[2];
            h1 = b[1] + b[2] + b[3] - a[1] * (b[1] + b[2] - a[1] * b[1]) - a[2] * b[1];
            if (h1 == 0) f3 = 1000; else f3 = 1.0 / h1;
            for (i = 1; i <= m; i++) q[i] = (a[i + 2] - a[1] * a[i + 1] + hvkl * a[i]) * f3;
            for (i = 2; i <= m; i++) p[i] = (b[i + 2] - a[1] * b[i + 1] + hvkl * b[i]) * f3;
        }

        //---------------------------------------------------------------------------
////---------------------------------------------------------------------------

        public void kt_aus_tetab0(ref double k, ref double t1, ref double t2, double t0L, double[] teta, int m,
                              ref string typ, ref string error)
        /* version teta with bo !!   1. Wert a1 auf Index 1*/
        {
            double c, c1, c2, c3, a1, a2, b1, b2, sa, sb, b0;
            int i, j, m2;
            error = "";
            if (typ == "adc") { k = 0; t1 = 0; t2 = 0; error = "adc"; goto ex_kt; };
            j = 0; m2 = 2 * m;
            for (i = 1; i <= m2 + 1; i++) if (teta[i] != 0) j = j + 1;
            if (j != 0)
            {
                k = 0; t1 = 0; t2 = 0; a1 = teta[1]; typ = ""; b0 = teta[1 + m];
                if ((Math.Abs(b0) > 1e-7) && (m < 3))
                {
                    t1 = 0; t2 = 0; typ = "b0>0";
                    sa = 0; sb = teta[1 + m]; /*b0*/
                    for (i = 1; i <= m; i++) { sa = sa + teta[i]; sb = sb + teta[i + m + 1]; }
                    if (Math.Abs(1.0 + sa) < 1.0e-20) k = 1.0e20; else k = sb / (1.0 + sa);
                    goto ex_kt;
                }
                if (a1 >= 0) { k = 0; t1 = 0; t2 = 0; error = a1mustbenegative; goto ex_kt; }
                else
                {
                    if (m == 1)
                    {
                        b1 = teta[3];
                        if (a1 == -1)
                        {
                            k = 1.0e10 * b1 / t0L; t1 = 1.0e10; typ = "I";
                        }
                        else
                        {
                            t1 = -t0L / Math.Log(-a1);
                            k = b1 / (1.0 + a1);
                            typ = "PT1";
                        }  /*else*/
                    }  /*if ( m=1*/
                    if (m == 2)
                    {
                        a2 = teta[2]; b1 = teta[4]; b2 = teta[5];
                        if (a2 <= 0) { k = 0; t1 = 0; t2 = 0; typ = "nix"; }
                        else
                        {
                            c1 = Math.Abs(b1 + b2);
                            if (c1 <= 0.0001)
                            {
                                c1 = a1 * a1 / 4.0 - a2;
                                if (c1 < 0)
                                {
                                    c3 = Math.Sqrt(a2);
                                    c2 = Math.Log(c3);
                                    c3 = -a1 / 2.0 / c3;
                                    c1 = -1.0 / c2 * Math.Atan(Math.Sqrt(1.0 - c3 * c3) / c3);
                                    t1 = 1.0 / Math.Sqrt(1.0 + c1 * c1);      /*d*/
                                    t2 = -c2 / t1 / t0L;             /*wo*/
                                    typ = "DT2";
                                }
                                else
                                {
                                    c3 = -a1 / 2.0 - Math.Sqrt(c1);
                                    c2 = -a1 / 2.0 + Math.Sqrt(c1);
                                    typ = "D2T1";
                                    t1 = -t0L / Math.Log(c3); t2 = -t0L / Math.Log(c2);
                                }
                                k = b1 * (t1 - t2) / (c3 - c2);

                            } /*dt2*/
                            else
                            {
                                c = (1.0 + a1 + a2) / (b1 + b2);
                                if ((Math.Abs(c) < 0.001))     /*it1*/
                                {
                                    if (a1 >= -1) { k = 1.0e5; t1 = 0; t2 = 0; error = "a1 wrong"; goto ex_kt; };
                                    typ = "IT1";
                                    t1 = -t0L / Math.Log(-1.0 - a1);
                                    k = (b1 + b2) / t0L / (1.0 - a2);
                                }   /*it1*/
                                else    /*2pt1*/
                                {
                                    k = 1.0 / c;
                                    c1 = a1 * a1 / 4.0 - a2;
                                    if (c1 < 0)
                                    {
                                        c3 = Math.Sqrt(a2);
                                        c2 = Math.Log(c3);
                                        c3 = -a1 / 2.0 / c3;
                                        c1 = -1.0 / c2 * Math.Atan(Math.Sqrt(1.0 - c3 * c3) / c3);
                                        t1 = 1.0 / Math.Sqrt(1.0 + c1 * c1);      /*d*/
                                        t2 = -c2 / t1 / t0L;             /*wo*/
                                        typ = "PT2";
                                    }
                                    else
                                    {
                                        c3 = -a1 / 2.0 - Math.Sqrt(c1);
                                        c2 = -a1 / 2.0 + Math.Sqrt(c1);
                                        if ((c2 > 0) && (c3 > 0))
                                        {  // at special cases c2 or c3 could be negative --> nix
                                            typ = "2PT1";
                                            t1 = -t0L / Math.Log(c3); t2 = -t0L / Math.Log(c2);
                                        }
                                        else typ = "nix";
                                    }
                                }  /*2pt1*/
                            }  /*else dt2*/
                        }
                    } /* if ( m=2*/
                }  /*else a1 negativ */
                if (m > 2)
                {   /* calc HF(z=1) */
                    sa = 0; sb = teta[1 + m]; /*b0*/
                    for (i = 1; i <= m; i++) { sa = sa + teta[i]; sb = sb + teta[i + m + 1]; };
                    if (Math.Abs(1 + sa) < 1.0e-20) k = 1.0e20; else k = sb / (1.0 + sa);
                    typ = "m>2";
                }  /*if ( m>2*/
            }
            else /* case if ( teta complete is 0 */
            {
                typ = "000";   /* if ( teta not defined */
                k = 0; t1 = 0; t2 = 0; error = tetanotdefined;
            }
        ex_kt: ;
        } /*kt_aus_tetab0 */




    }
}